<?php

/**
 * Description of Answer
 *
 * @author jkraaijeveld
 */
class Answer extends ResearchToolObject {
    public $question;
	public $values;
    
    /**
     * Constructor for an Answer object
     * @param type $uid : The uid of the Answer object.
     * @param type $question : The Question object this Answer answers.
     * @param type $values : An array of strings, containing the answers.
     */
    public function __construct($uid = null, $question = null, $values = null) {
      if(!isset($uid))
      {
            $uid = md5(uniqid(rand(), true));
      }
      $this->uid = $uid;
      $this->question = $question;
      $this->values = $values;
	}
	
	/**
	 * function evaluate()
	 * Evaluates the references and fills in the objects for them instead.
	 */
	public function evaluate()
	{
		if(is_string($this->question))
		{
			$dbi = new DatabaseInterface();
			$result = $dbi->get("question", array("code" => $this->question));
			if(!isset($result[0]))
				return false;
			$this->question = $result[0];
		}
		return true;

	}
}

?>
