<?php

/**
 * AnswerSet is a collection of answers corresponding to a Session
 *
 */
class AnswerSet extends ResearchToolObject{
	public $survey;
	public $respondent;
	public $answers;

	/**
	 * Constructor for an AnswerSet object
	 * @param type $uid
	 * @param type $survey
	 * @param type $respondent
	 * @param type $answers
	 */
	public function __construct($uid=null, $survey=null, $respondent=null, $answers=null)
	{
		if(!isset($uid))
		{
			$uid = md5(uniqid(rand(), true));
		}
		$this->uid = $uid;
		$this->survey = $survey;
		$this->respondent = $respondent;
		$this->answers = $answers;
	}

	/**
	 * function evaluate()
	 * evaluates the references of survey, respondent and answers.
	 */
	public function evaluate()
	{
		$dbi = new DatabaseInterface();
		if(is_string($this->survey))
		{
			$result = $dbi->get("survey", array("uid" => $this->survey));
			if(!isset($result[0]))
				return false;
			$this->survey = $result[0];
		}
		if(is_string($this->respondent))
		{
			$result = $dbi->get("respondent", array("uid" => $this->respondent));
			if(!isset($result[0]))
				return false;
			$this->respondent = $result[0];
		}
		if(!empty($this->answers) && is_string($this->answers[0]))
		{
			$newanswers = array();
			foreach($this->answers as $answer)
			{
				$result = $dbi->get("answer", array("uid" => $answer));
				if(!isset($result[0]))
					return false;
				$newanswers[] = $result[0];
			}
			$this->answers = $newanswers;
		}
		return true;
	}
}

