<?php
/**
 * Description of SessionInstance
 *
 * @author jkraaijeveld
 */

class SessionInstance extends ResearchToolObject
{
	public $title;
	public $location;
	public $facilitator;
	public $starttime;
	public $endtime;
	public $notes;
	public $session;
	public $resultset;

	/**
	 * Constructor for a SessionInstance object
	 * @param type $uid
	 * @param type $title
	 * @param type $location
	 * @param type $facilitator
	 * @param type $starttime
	 * @param type $endtime
	 * @param type $notes
	 * @param type $session
	 * @param type $resultset
	 */
	public function __construct($uid = null, $title = null, $location = null, $facilitator = null, $starttime = null, $endtime = null, $notes = null, $session = null, $resultset = null)
	{
		if(!isset($uid))
		{
			$uid = md5(uniqid(rand(), true));
		}
		$this->uid = $uid;
		$this->title = $title;
		$this->location = $location;
		$this->facilitator = $facilitator;
		$this->starttime = $starttime;
		$this->endtime = $endtime;
		$this->notes = $notes;
		$this->session = $session;
		$this->resultset = $resultset;
	}

	/*
	 * function evaluate()
	 * Evaluates all the references of this object.
	 */
	public function evaluate()
	{
		$dbi = new DatabaseInterface();
		if(is_string($this->facilitator))
		{
			$result = $dbi->get("user", array("uid" => $this->facilitator));
			if(!isset($result[0]))
				return false;
			$this->facilitator = $result[0];
		}

		if(is_string($this->session))
		{
			$result = $dbi->get("session", array("uid" => $this->session));
			if(!isset($result[0]))
				return false;
			$this->session = $result[0]; 
		}

		if(is_string($this->resultset))
		{
			$result = $dbi->get("resultset", array("uid" => $this->resultset));
			if(!isset($result[0]))
				return true;
			$newResultSets[] = $result[0];
		}
		return true;
	}
			

}
